
import ctypes
import os
import threading
from time import sleep

BOOLEAN = ctypes.c_ubyte
FALSE = 0
TRUE = 1

usDevID = ctypes.c_ushort(5206)

def scanFunc():
  global LL_USB_Lib
  global usDevID
  bErrorType = ctypes.c_ubyte(0)

  # single chan scan command
  CMND_SINGLE_CHAN_SCAN = 0x1
  # multi chan scan command
  CMND_MULTI_CHAN_SCAN = 0x2 
  # multi chan cal scan command
  CMND_MULTI_CHAN_CAL_SCAN = 0x3 
  # single chan scan with digin command
  CMND_SINGLE_CHAN_DIGIN_SCAN = 0x4 
  # multi chan scan with digin command
  CMND_MULTI_CHAN_DIGIN_SCAN = 0x5 
  # multi chan cal scan with digin command
  CMND_MULTI_CHAN_CAL_DIGIN_SCAN = 0x6 
  
  #BOOLEAN EX_SetScanType ( USHORT usDevID, BYTE bScanType );
  bScanType = ctypes.c_ubyte(CMND_SINGLE_CHAN_SCAN)
  LL_USB_Lib.EX_SetScanType.argtypes = [ctypes.c_ushort, ctypes.c_ubyte]


  print "=============================================";
  print "====== S C A N N I N G   P R O C E S S ======";
  print "=============================================";

  LL_USB_Lib.EX_SetScanType.restypes = ctypes.c_byte
  print "setting scan type CMND_SINGLE_CHAN_SCAN . . .";
  
  if LL_USB_Lib.EX_SetScanType(usDevID, bScanType):
    #print "  scan type set success\n"
    bErrorType = 0
  else:
    print "failed scan type set\n"
    return

  #BOOLEAN EX_SetDataLogOptions ( USHORT usDevID, UINT uiDataLogMethod, UINT uiLogFileMaxSize, UINT uiMisc );
  # scan data log options from API documentation
  SCAN_USE_DATA_LOG_FILE = 0x1
  SCAN_USE_DATA_ARRAY = 0x2
  SCAN_STOP_ON_DATA_ARRAY_WRAP = 0x4
  SCAN_LIMIT_LOG_FILE_SIZE = 0x8
  uiDataLogMethod = ctypes.c_uint(SCAN_USE_DATA_ARRAY) #to log to file too, add:  " | SCAN_USE_DATA_LOG_FILE"
  LL_USB_Lib.EX_SetDataLogOptions.argtypes = [ctypes.c_ushort, ctypes.c_uint, ctypes.c_uint, ctypes.c_uint]
  LL_USB_Lib.EX_SetDataLogOptions.restypes = ctypes.c_byte
  print "setting scan log type SCAN_USE_DATA_ARRAY . . .";
  if LL_USB_Lib.EX_SetDataLogOptions(usDevID, uiDataLogMethod, 0, 0):
    #print "  scan data log options set success\n"
    bErrorType = 0
  else:
    print "failed scan data log options set\n"
    return

  #BOOLEAN EX_Run ( USHORT usDevID );
  LL_USB_Lib.EX_Run.argtypes = [ctypes.c_ushort]
  LL_USB_Lib.EX_Run.restypes = ctypes.c_byte
  print "calling EX_Run . . .";
  if LL_USB_Lib.EX_Run(usDevID):
    print "  EX_Run success\n";
    #bErrorType = 0
  else:
    print "failed EX_Run\n"
    return

  #just to test scan accumulation/recovery in buffer
  #sleep(2.5)

  pfStillScanning = ctypes.c_ubyte()
  puiStatusCode = ctypes.c_uint()

  #BOOLEAN EX_CheckScanStatus ( USHORT usDevID, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiStatusCode) );
  LL_USB_Lib.EX_CheckScanStatus.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_ubyte), ctypes.POINTER(ctypes.c_uint)]
  LL_USB_Lib.EX_CheckScanStatus.restypes = ctypes.c_ubyte

  pdblDataBuff=(ctypes.c_double*400)()
  #following just for testing against valid return of first data read
  #for x in range(0, 400): pdblDataBuff[x]=2.3

  uiNumScansToReturn = ctypes.c_uint
  fGetAllRequested = ctypes.c_byte
  fGetAllRequested = 0
  puiNumScansReturned = ctypes.c_uint()

  uiTotalScansToGet = ctypes.c_uint
  uiTotalScansToGet = 20
  uiTotalScansGot = ctypes.c_uint
  uiTotalScansGot = 0

  array_of_size_uint = ctypes.c_uint*1
  puiTotalBuffSize = array_of_size_uint()
  puiTotalBuffSize[0]=400

  puiNumScansRemainingInBuff = ctypes.c_uint()

  #BOOLEAN EX_GetScanDataDbl ( USHORT usDevID, double* pdblDataBuff, UINT uiNumScansToReturn, BOOLEAN fGetAllRequested,
  #        UINT* puiNumScansReturned, UINT* puiNumScansRemainingInBuff, BOOLEAN* pfStillScanning, UINT* puiTotalBuffSize, UINT* puiStatusCode);
  LL_USB_Lib.EX_GetScanDataDbl.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double), ctypes.c_uint, ctypes.c_ubyte, \
    ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_ubyte), ctypes.POINTER(ctypes.c_uint), ctypes.POINTER(ctypes.c_uint)]
  LL_USB_Lib.EX_GetScanDataDbl.restypes = ctypes.c_ubyte

  #following two lines just for testing
  #LL_USB_Lib.EX_CheckScanStatus(usDevID, puiNumScansRemainingInBuff, pfStillScanning, puiStatusCode)
  #print ("  got puiNumScansRemainingInBuff: %d\n" % puiNumScansRemainingInBuff.value)

  while (1==1):
    if LL_USB_Lib.EX_CheckScanStatus(usDevID, puiNumScansRemainingInBuff, pfStillScanning, puiStatusCode):
      if(pfStillScanning == 0):
        print ("  scan stopped\n")
        break #still need to stop/complete scan
    else:
      print ("  failed EX_CheckScanStatus\n")
      break #still need to stop/complete scan
    uiNumScansToReturn = puiNumScansRemainingInBuff.value
    if(uiNumScansToReturn > 400): uiNumScansToReturn = 400
    #print ("  got uiNumScansToReturn: %d\n" % uiNumScansToReturn)
    
    if (uiNumScansToReturn > 0):
      if LL_USB_Lib.EX_GetScanDataDbl(usDevID, pdblDataBuff, uiNumScansToReturn, fGetAllRequested, puiNumScansReturned, puiNumScansRemainingInBuff, pfStillScanning, puiTotalBuffSize, puiStatusCode):
        #print ("  got puiNumScansReturned: %d\n" % puiNumScansReturned.value)
        #print ("  got puiNumScansRemainingInBuff: %d\n" % puiNumScansRemainingInBuff.value)
        for x in range(0, uiNumScansToReturn):
          print ("scan: {:3d}  volts: {:f}".format(uiTotalScansGot, float(pdblDataBuff[x])))
          uiTotalScansGot = uiTotalScansGot + 1
          if(uiTotalScansGot >= uiTotalScansToGet): break  #break for()
        if(uiTotalScansGot >= uiTotalScansToGet): break    #break while()

  #BOOLEAN EX_Stop ( USHORT usDevID ); 
  LL_USB_Lib.EX_Stop.argtypes = [ctypes.c_ushort]
  LL_USB_Lib.EX_Stop.restypes = ctypes.c_byte
  print "\ncalling EX_Stop . . .";
  if LL_USB_Lib.EX_Stop(usDevID):
    print "  EX_Stop success";
    #bErrorType = 0
  else:
    print "failed EX_Stop\n"
    return
  
  #BOOLEAN EX_StopComplete ( USHORT usDevID );
  LL_USB_Lib.EX_StopComplete.argtypes = [ctypes.c_ushort]
  LL_USB_Lib.EX_StopComplete.restypes = ctypes.c_byte
  print "calling EX_StopComplete . . .";
  if LL_USB_Lib.EX_StopComplete(usDevID):
    print "  EX_StopComplete success\n";
    #bErrorType = 0
  else:
    print "failed EX_StopComplete\n"
    return
  return

global sizex, sizey

def main():
  global sizex, sizey
  global LL_USB_Lib
  #initialize library
  LL_USB_Lib = ctypes.windll.LoadLibrary('.\\LL_USB2k.dll')
  os.system("cls")

  #from: https://gist.github.com/jtriley/1108174
  try:
    from ctypes import windll, create_string_buffer
    # stdin handle is -10
    # stdout handle is -11
    # stderr handle is -12
    h = windll.kernel32.GetStdHandle(-12)
    csbi = create_string_buffer(22)
    res = windll.kernel32.GetConsoleScreenBufferInfo(h, csbi)
    if res:
        (bufx, bufy, curx, cury, wattr,
         left, top, right, bottom,
         maxx, maxy) = struct.unpack("hhhhHhhhhhh", csbi.raw)
        sizex = right - left + 1
        sizey = bottom - top + 1
        #use sizex and sizey to return console size to original,
        # after call to this function, if desired
        #return sizex, sizey
  except:
    pass
  os.system('mode con: cols=80 lines=58')

  rate = float(100.0)
  LL_USB_Lib.EX_ConnectOneDevice.argtypes = [ctypes.c_ushort, ctypes.c_double, ctypes.c_ubyte]

  LL_USB_Lib.EX_ConnectOneDevice.restypes = ctypes.c_byte
  print "\nsigning on (may take a while) - WAIT . . ."

  bChan = ctypes.c_ubyte(0)
  bRetVal = ctypes.c_ubyte(0)

  if LL_USB_Lib.EX_ConnectOneDevice(usDevID, rate, bChan):
    print "  signed on";
  else:
    print "not signed on\n"
    return

  dblMilliVolts = ctypes.c_double(100)
  print "getting a conversion - WAIT . . .";
  LL_USB_Lib.EX_GetOneConversion.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double)]
  LL_USB_Lib.EX_GetOneConversion.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_GetOneConversion(usDevID, dblMilliVolts):  
    print ("  got volts chan0: %f" % (dblMilliVolts.value / 1000));
  else:
    print ("  failed reading conversion\n")
    return

  bChan = ctypes.c_ubyte(6)
  bLastDigin = ctypes.c_ubyte(0)
  print "changing to  full-scale channel 6 - WAIT . . ."
  LL_USB_Lib.EX_SendChan.argtypes = [ctypes.c_ushort, ctypes.c_ubyte, ctypes.POINTER(ctypes.c_ubyte)]
  LL_USB_Lib.EX_SendChan.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_SendChan(usDevID, bChan, bLastDigin):  
    print ("  sendChan success, lastDigin: %d" % bLastDigin.value);
  else:
    print ("  failed sending channel\n")
    return
  sleep(0.5)

  print "getting a conversion - WAIT . . .";
  LL_USB_Lib.EX_GetOneConversion.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double)]
  LL_USB_Lib.EX_GetOneConversion.restypes = ctypes.c_ubyte
  LL_USB_Lib.EX_GetOneConversion(usDevID, dblMilliVolts)  
  if LL_USB_Lib.EX_GetOneConversion(usDevID, dblMilliVolts):  
    print ("  got volts chan6: %f" % (dblMilliVolts.value / 1000));
  else:
    print ("  failed reading conversion\n")
    return


  bDAC = ctypes.c_ubyte(0)
  dblDACVolts = ctypes.c_double(3.5)
  print "setting DAC0 to 3.5 volts - WAIT . . .";
  LL_USB_Lib.EX_SendDAC.argtypes = [ctypes.c_ushort, ctypes.c_double, ctypes.c_ubyte]
  LL_USB_Lib.EX_SendDAC.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_SendDAC(usDevID, dblDACVolts, bDAC): 
    print ("  sendDAC success");
  else:
    print ("  failed setting DAC\n")
    return  

  bChan = 3
  print "changing to channel 3 (should be DAC0 volts)";
  print "  see pythonSampleAppMini.pdf for how to connect - WAIT . . .";
  LL_USB_Lib.EX_SendChan.argtypes = [ctypes.c_ushort, ctypes.c_ubyte, ctypes.POINTER(ctypes.c_ubyte)]
  LL_USB_Lib.EX_SendChan.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_SendChan(usDevID, bChan, bLastDigin):  
    print ("  sendChan success, lastDigin: %d" % bLastDigin.value);
  else:
    print ("  failed sending channel\n")
    return
  sleep(0.5)

  print "getting a conversion - WAIT . . .";
  LL_USB_Lib.EX_GetOneConversion.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double)]
  LL_USB_Lib.EX_GetOneConversion.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_GetOneConversion(usDevID, dblMilliVolts):  
    print ("  got volts chan3: %f" % (dblMilliVolts.value / 1000));
  else:
    print ("  failed reading conversion");
    return

  dblActualRate = ctypes.c_double(1000)
  print "checking 'actual rate when 1000Hz is requested - WAIT . . .";
  LL_USB_Lib.EX_GetCalculatedRate.argtypes = [ctypes.c_ushort, ctypes.POINTER(ctypes.c_double)]
  LL_USB_Lib.EX_GetCalculatedRate.restypes = ctypes.c_ubyte
  if LL_USB_Lib.EX_GetCalculatedRate(usDevID, dblActualRate): 
    print ("  1000Hz would be: %f\n" % dblActualRate.value)
  else:
    print ("  failed getting actual rate for 1000Hz\n")
    return
  scanFunc()
  print "exiting application - WAIT . . .";

  return

sizex = 80
sizey = 25

if __name__ == '__main__':
  main()

#os.system('mode con: cols=%d lines=%d' % (sizex, sizey))



